; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - CodeGenerator.pb
; Version du fichier : 0.9.10
; Programmation : En cours
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 03-10-2014
; Mise  jour : 08-02-2019
; Code PureBasic : V5.70 LTS
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule CodeGenerator
  
  Declare.s Generate(Flag.b = 0)
  Declare SaveProjectFile(FileName.s)
  Declare LoadProjectFile(FileName.s)

EndDeclareModule

Module CodeGenerator
  
  Procedure.s DeclarePublicProcedureCode()
    
    Buffer.s + "DeclareModule " + General::GetModuleName() + LineFeed::Twin()
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE
      Buffer + Comments::Section(Language::Message("Structure declaration"), 1)
      Buffer + Field::GenerateStructures(0)
    EndIf
    
    Buffer + Field::GenerateMultipleInstanceHelper(Field::#METHOD_MODE_DECLARE)
    
    If BasicMethods::GetObservator() = 1
      Buffer + BasicMethods::DeclareObservators()
    EndIf
    
    If BasicMethods::GetMutator() = 1
      Buffer + BasicMethods::DeclareMutators()
    EndIf
    
    If General::GetSpecialMethods() = #True
      Buffer + Field::MethodsSpecial(Field::#METHOD_MODE_DECLARE)
    EndIf  
    
    If BasicMethods::GetUpdate() = 1
      Buffer + BasicMethods::DeclareUpdate()
    EndIf
    
    If BasicMethods::GetInitialize() = 1
      Buffer + BasicMethods::DeclareInitialize()
    EndIf
    
    If BasicMethods::GetReset() = 1
      Buffer + BasicMethods::DeclareReset()
    EndIf
    
    If BasicMethods::GetClear() = 1
      Buffer + BasicMethods::DeclareClear()
    EndIf

    If General::GetIsStaticArrayPresent() And StaticArrayMethods::GetQuickSortAscendant() = 1
      Buffer + StaticArrayMethods::DeclareQuickSortAscendant()
    EndIf
    
    If General::GetIsStaticArrayPresent() And StaticArrayMethods::GetQuickSortDescendant() = 1
      Buffer + StaticArrayMethods::DeclareQuickSortDescendant()
    EndIf
    
    If General::GetIsStaticArrayPresent() And StaticArrayMethods::GetLinearSearch() = 1
      Buffer + StaticArrayMethods::DeclareLinearSearch()
    EndIf
    
    If General::GetIsStaticArrayPresent() And StaticArrayMethods::GetBinarySearch() = 1
      Buffer + StaticArrayMethods::DeclareBinarySearch()
    EndIf
    
    If General::GetIsStaticArrayPresent() And StaticArrayMethods::GetFixedLenghtQueue() = 1
      Buffer + StaticArrayMethods::DeclareFixedLenghtQueue()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetSort() = 1
      Buffer + LinkedListMethods::DeclareSort()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetLinearSearch() = 1
      Buffer + LinkedListMethods::DeclareLinearSearch()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetBinarySearch() = 1
      Buffer + LinkedListMethods::DeclareBinarySearch()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetAdd() = 1
      Buffer + LinkedListMethods::DeclareAdd()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetSelect() = 1
      Buffer + LinkedListMethods::DeclareSelect()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetFirst() = 1
      Buffer + LinkedListMethods::DeclareFirst()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetLast() = 1
      Buffer + LinkedListMethods::DeclareLast()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetPrevious() = 1
      Buffer + LinkedListMethods::DeclarePrevious()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetNext() = 1
      Buffer + LinkedListMethods::DeclareNext()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetDelete() = 1
      Buffer + LinkedListMethods::DeclareDelete()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetReset() = 1
      Buffer + LinkedListMethods::DeclareReset()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetClear() = 1
      Buffer + LinkedListMethods::DeclareClear()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetIndex() = 1
      Buffer + LinkedListMethods::DeclareIndex()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetSize() = 1
      Buffer + LinkedListMethods::DeclareSize()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetInsert() = 1
      Buffer + LinkedListMethods::DeclareInsert()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetExtract() = 1
      Buffer + LinkedListMethods::DeclareExtract()
    EndIf
    
    If General::GetIsDynamicArrayPresent() And DynamicArrayMethods::GetSort() = 1
      Buffer + DynamicArrayMethods::DeclareSort()
    EndIf
    
    If General::GetIsDynamicArrayPresent() And DynamicArrayMethods::GetLinearSearch() = 1
      Buffer + DynamicArrayMethods::DeclareLinearSearch()
    EndIf
    
    If General::GetIsDynamicArrayPresent() And DynamicArrayMethods::GetBinarySearch() = 1
      Buffer + DynamicArrayMethods::DeclareBinarySearch()
    EndIf
    
    If General::GetIsDynamicArrayPresent() And DynamicArrayMethods::GetInsert() = 1
      Buffer + DynamicArrayMethods::DeclareInsert()
    EndIf
    
    If General::GetIsDynamicArrayPresent() And DynamicArrayMethods::GetExtract() = 1
      Buffer + DynamicArrayMethods::DeclareExtract()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetAdd() = 1
      Buffer + MapMethods::DeclareAdd()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetClear() = 1
      Buffer + MapMethods::DeclareClear()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetSize() = 1
      Buffer + MapMethods::DeclareSize()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetReset() = 1
      Buffer + MapMethods::DeclareReset()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetDelete() = 1
      Buffer + MapMethods::DeclareDelete()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetFind() = 1
      Buffer + MapMethods::DeclareFind()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetNext() = 1
      Buffer + MapMethods::DeclareNext()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetKey() = 1
      Buffer + MapMethods::DeclareKey()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetInsert() = 1
      Buffer + MapMethods::DeclareInsert()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetExtract() = 1
      Buffer + MapMethods::DeclareExtract()
    EndIf
    
    If MathsMethods::GetEqual() = 1
      Buffer + MathsMethods::DeclareEqual()
    EndIf
    
    If MathsMethods::GetPlus() = 1
      Buffer + MathsMethods::DeclarePlus()
    EndIf
    
    If MathsMethods::GetMinus() = 1
      Buffer + MathsMethods::DeclareMinus()
    EndIf
    
    If MathsMethods::GetProduct() = 1
      Buffer + MathsMethods::DeclareProduct()
    EndIf
    
    If MathsMethods::GetDivide() = 1
      Buffer + MathsMethods::DeclareDivide()
    EndIf
    
    If MathsMethods::GetProductByScalar() = 1
      Buffer + MathsMethods::DeclareProductByScalar()
    EndIf
    
    If MathsMethods::GetDivideByScalar() = 1
      Buffer + MathsMethods::DeclareDivideByScalar()
    EndIf
    
    If MathsMethods::GetCopy() = 1
      Buffer + MathsMethods::DeclareCopy()
    EndIf
    
    If MathsMethods::GetCompare() = 1
      Buffer + MathsMethods::DeclareCompare()
    EndIf
    
    If MathsMethods::GetSwapping() = 1
      Buffer + MathsMethods::DeclareSwapping()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And General::GetIsSquareMatrix()
      Buffer + MathsMethods::DeclareIdentity()
      Buffer + MathsMethods::DeclareTranspose()
      Buffer + MathsMethods::DeclareDeterminant()
      Buffer + MathsMethods::DeclareInverse()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And General::GetIsMatrix()
      Buffer + MathsMethods::DeclareRandomize()
      Buffer + MathsMethods::DeclareFormatLine()
      Buffer + MathsMethods::DeclareUnformatLine()
    EndIf
    
    If XMLFileMethods::GetNodeWithChildNode() = 1
      Buffer + XMLFileMethods::DeclareSetNode()
      Buffer + XMLFileMethods::DeclareGetNode()
    EndIf
    
    If XMLFileMethods::GetNodeWithAttributes() = 1
      Buffer + XMLFileMethods::DeclareSetAttributes()
      Buffer + XMLFileMethods::DeclareGetAttributes()
    EndIf
    
    If XMLFileMethods::GetAddCollectAttributes() = 1
      Buffer + XMLFileMethods::DeclareAddAttributes()
      Buffer + XMLFileMethods::DeclareCollectAttributes()
    EndIf
    
    If XMLFileMethods::GetCreateLoadFile() = 1
      Buffer + XMLFileMethods::DeclareCreateFile()  
      Buffer + XMLFileMethods::DeclareLoadFile()
    EndIf
    
    If XMLFileMethods::GetCatchFile() = 1
      Buffer + XMLFileMethods::DeclareCatchFile()
    EndIf
    
    If JSONFileMethods::GetCreateLoadFile() = 1
      Buffer + JSONFileMethods::DeclareCreateFile()
      Buffer + JSONFileMethods::DeclareLoadFile()
    EndIf
    
    If DataBaseMethods::GetCreateTable() = 1
      Buffer + DataBaseMethods::DeclareCreateTable()
    EndIf
    
    If DataBaseMethods::GetDropTable() = 1
      Buffer + DataBaseMethods::DeclareDropTable()
    EndIf
    
    If DataBaseMethods::GetTruncateTable() = 1
      Buffer + DataBaseMethods::DeclareTruncateTable()
    EndIf
    
    If DataBaseMethods::GetSelectTable() = 1
      Buffer + DataBaseMethods::DeclareSelectTable()
    EndIf
    
    If DataBaseMethods::GetCountRow() = 1
      Buffer + DataBaseMethods::DeclareCountRow()
    EndIf
    
    If DataBaseMethods::GetOpenFile() = 1
      Buffer + DataBaseMethods::DeclareOpenFile()
    EndIf
    
    If DataBaseMethods::GetSendModuleTo() = 1
      Buffer + DataBaseMethods::DeclareSendModuleTo()
    EndIf
    
    If DataBaseMethods::GetLoadModuleFrom() = 1
      Buffer + DataBaseMethods::DeclareLoadModuleFrom()
    EndIf
    
    If DataBaseMethods::GetVacummize() = 1
      Buffer + DataBaseMethods::DeclareVacummize()
    EndIf

    If PrefsFileMethods::GetReadWriteGroup() = 1
      Buffer + PrefsFileMethods::DeclareReadGroup()
      Buffer + PrefsFileMethods::DeclareWriteGroup()
    EndIf
    
    If PrefsFileMethods::GetCreateOpenFile() = 1
      Buffer + PrefsFileMethods::DeclareCreateFile()
      Buffer + PrefsFileMethods::DeclareOpenFile()
    EndIf
    
    If BinaryFileMethods::GetReadWrite() = 1
      Buffer + BinaryFileMethods::DeclareRead()
      Buffer + BinaryFileMethods::DeclareWrite()
    EndIf
    
    If BinaryFileMethods::GetCreateFile() = 1
      Buffer + BinaryFileMethods::DeclareCreateFile()
    EndIf
    
    If BinaryFileMethods::GetOpenFile() = 1
      Buffer + BinaryFileMethods::DeclareOpenFile()
    EndIf
    
    If BinaryFileMethods::GetReadFile() = 1
      Buffer + BinaryFileMethods::DeclareReadFile()
    EndIf
    
    If EncodedFileMethods::GetReadWrite() = 1
      Buffer + EncodedFileMethods::DeclareRead()
      Buffer + EncodedFileMethods::DeclareWrite()
    EndIf
    
    If EncodedFileMethods::GetCreateFile() = 1
      Buffer + EncodedFileMethods::DeclareCreateFile()
    EndIf
    
    If EncodedFileMethods::GetOpenFile() = 1
      Buffer + EncodedFileMethods::DeclareOpenFile()
    EndIf
    
    If EncodedFileMethods::GetReadFile() = 1
      Buffer + EncodedFileMethods::DeclareReadFile()
    EndIf
    
    If CryptedFileMethods::GetReadWrite() = 1
      Buffer + CryptedFileMethods::DeclareRead()
      Buffer + CryptedFileMethods::DeclareWrite()
    EndIf
    
    If CryptedFileMethods::GetCreateFile() = 1
      Buffer + CryptedFileMethods::DeclareCreateFile()
    EndIf
    
    If CryptedFileMethods::GetOpenFile() = 1
      Buffer + CryptedFileMethods::DeclareOpenFile()
    EndIf
    
    If CryptedFileMethods::GetReadFile() = 1
      Buffer + CryptedFileMethods::DeclareReadFile()
    EndIf
    
    If DebuggingMethods::GetDebugging() = 1
      Buffer + DebuggingMethods::DeclareDebugging()
    EndIf
    
    Buffer + LineFeed::Single() + "EndDeclareModule" + LineFeed::Twin()
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s ModuleDefinitionCode()

    Buffer.s + "Module " + General::GetModuleName() + LineFeed::Twin()
    
    If General::GetInstanceStyle() <> Field::#INSTANCE_STYLE_OFF_MODULE
      
      StaticArrayCte.s = Field::GenerateStaticArraySizeConstants()
      
      If StaticArrayCte <> ""
        Buffer + Comments::Section(Language::Message("Size Array Constants"), 1)
        Buffer + StaticArrayCte + LineFeed::Single()
      EndIf
      
      CteEnum.s = Field::GenerateEnumeration()
      
      If CteEnum <> ""
        Buffer + Comments::Section(Language::Message("Constants Enumeration"), 1)
        Buffer + CteEnum + LineFeed::Single()
      EndIf
      
      If Field::CountStructure() = 1
        Buffer + Comments::Section(Language::Message("Structure declaration"), 1)
      Else
        Buffer + Comments::Section(Language::Message("Structures declaration"), 1)
      EndIf
      
      Buffer + Field::GenerateStructures(1)
      
    EndIf
    
    MultipleInstanceHelper.s = Field::GenerateMultipleInstanceHelper(Field::#METHOD_MODE_PROCEDURE)
    
    If MultipleInstanceHelper <> ""
      Buffer + Comments::Section(Language::Message("Multiple Instances Helper"), 1)
      Buffer + MultipleInstanceHelper
    EndIf
    
    If BasicMethods::GetObservator() >= 1
      Buffer + Comments::Section(Language::Message("The observators"), 1)
      Buffer + BasicMethods::DefineObservators()
    EndIf
    
    If BasicMethods::GetMutator() >= 1
      Buffer + Comments::Section(Language::Message("The mutators"), 1)
      Buffer + BasicMethods::DefineMutators()
    EndIf
    
    If General::GetSpecialMethods() = #True
      Buffer + Comments::Section(Language::Message("The Special operator(s)"), 1)
      Buffer + Field::MethodsSpecial(Field::#METHOD_MODE_PROCEDURE)
    EndIf   
            
    If BasicMethods::GetUpdate() >= 1
      Buffer + Comments::Section(Language::Message("The Update operator"), 1)
      Buffer + BasicMethods::DefineUpdate()
    EndIf
    
    If BasicMethods::GetInitialize() >= 1
      Buffer + Comments::Section(Language::Message("The Initialize operator"), 1)
      Buffer + BasicMethods::DefineInitialize()
    EndIf
    
    If BasicMethods::GetReset() >= 1
      Buffer + Comments::Section(Language::Message("The Reset operator"), 1)
      Buffer + BasicMethods::DefineReset()
    EndIf
    
    If BasicMethods::GetClear() >= 1
      Buffer + Comments::Section(Language::Message("The Clear operator"), 1)
      Buffer + BasicMethods::DefineClear()
    EndIf
    
    If General::GetIsStaticArrayPresent() And StaticArrayMethods::GetQuickSortAscendant() >= 1
      Buffer + Comments::Section(Language::Message("The QuickSort Ascendant operator"), 1)
      Buffer + StaticArrayMethods::DefineQuickSortAscendant()
    EndIf
    
    If General::GetIsStaticArrayPresent() And StaticArrayMethods::GetQuickSortDescendant() >= 1
      Buffer + Comments::Section(Language::Message("The QuickSort Descendant operator"), 1)
      Buffer + StaticArrayMethods::DefineQuickSortDescendant()
    EndIf
    
    If General::GetIsStaticArrayPresent() And StaticArrayMethods::GetLinearSearch() >= 1
      Buffer + Comments::Section(Language::Message("The Linear Search operator"), 1)
      Buffer + StaticArrayMethods::DefineLinearSearch()
    EndIf
    
    If General::GetIsStaticArrayPresent() And StaticArrayMethods::GetBinarySearch() >= 1
      Buffer + Comments::Section(Language::Message("The Binary Search operator"), 1)
      Buffer + StaticArrayMethods::DefineBinarySearch()
    EndIf
    
    If General::GetIsStaticArrayPresent() And StaticArrayMethods::GetFixedLenghtQueue() >= 1
      Buffer + Comments::Section(Language::Message("The InsertTopBottomOut operator"), 1)
      Buffer + StaticArrayMethods::DefineFixedLenghtQueue()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetSort() >= 1
      Buffer + Comments::Section(Language::Message("The sort linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineSort()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetLinearSearch() >= 1
      Buffer + Comments::Section(Language::Message("The linear search linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineLinearSearch()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetBinarySearch() >= 1
      Buffer + Comments::Section(Language::Message("The binary search linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineBinarySearch()
    EndIf

    If General::GetIsLinkedListPresent() And LinkedListMethods::GetAdd() >= 1
      Buffer + Comments::Section(Language::Message("The Add to linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineAdd()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetSelect() >= 1
      Buffer + Comments::Section(Language::Message("The Select in linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineSelect()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetFirst() >= 1
      Buffer + Comments::Section(Language::Message("The First element in linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineFirst()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetLast() >= 1
      Buffer + Comments::Section(Language::Message("The Last element in linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineLast()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetPrevious() >= 1
      Buffer + Comments::Section(Language::Message("The Previous element in linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefinePrevious()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetNext() >= 1
      Buffer + Comments::Section(Language::Message("The Next element in linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineNext()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetDelete() >= 1
      Buffer + Comments::Section(Language::Message("The Delete element from linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineDelete()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetReset() >= 1
      Buffer + Comments::Section(Language::Message("The Reset linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineReset()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetClear() >= 1
      Buffer + Comments::Section(Language::Message("The Clear linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineClear()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetIndex() >= 1
      Buffer + Comments::Section(Language::Message("The Index in the linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineIndex()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetSize() >= 1
      Buffer + Comments::Section(Language::Message("The Size of the linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineSize()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetInsert() >= 1
      Buffer + Comments::Section(Language::Message("The Insert linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineInsert()
    EndIf
    
    If General::GetIsLinkedListPresent() And LinkedListMethods::GetExtract() >= 1
      Buffer + Comments::Section(Language::Message("The Extract linked list operator(s)"), 1)
      Buffer + LinkedListMethods::DefineExtract()
    EndIf
    
    If General::GetIsDynamicArrayPresent() And DynamicArrayMethods::GetSort() >= 1
      Buffer + Comments::Section(Language::Message("The sort dynamic array operator(s)"), 1)
      Buffer + DynamicArrayMethods::DefineSort()
    EndIf
    
    If General::GetIsDynamicArrayPresent() And DynamicArrayMethods::GetLinearSearch() >= 1
      Buffer + Comments::Section(Language::Message("The linear search dynamic array operator(s)"), 1)
      Buffer + DynamicArrayMethods::DefineLinearSearch()
    EndIf
    
    If General::GetIsDynamicArrayPresent() And DynamicArrayMethods::GetBinarySearch() >= 1
      Buffer + Comments::Section(Language::Message("The binary search dynamic array operator(s)"), 1)
      Buffer + DynamicArrayMethods::DefineBinarySearch()
    EndIf
    
    If General::GetIsDynamicArrayPresent() And DynamicArrayMethods::GetInsert() >= 1
      Buffer + Comments::Section(Language::Message("The Insert dynamic array operator(s)"), 1)
      Buffer + DynamicArrayMethods::DefineInsert()
    EndIf
    
    If General::GetIsDynamicArrayPresent() And DynamicArrayMethods::GetExtract() >= 1
      Buffer + Comments::Section(Language::Message("The Extract dynamic array operator(s)"), 1)
      Buffer + DynamicArrayMethods::DefineExtract()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetAdd() >= 1
      Buffer + Comments::Section(Language::Message("The Add to map operator(s)"), 1)
      Buffer + MapMethods::DefineAdd()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetClear() >= 1
      Buffer + Comments::Section(Language::Message("The Clear map operator(s)"), 1)
      Buffer + MapMethods::DefineClear()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetSize() >= 1
      Buffer + Comments::Section(Language::Message("The map Size operator(s)"), 1)
      Buffer + MapMethods::DefineSize()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetReset() >= 1
      Buffer + Comments::Section(Language::Message("The Reset map operator(s)"), 1)
      Buffer + MapMethods::DefineReset()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetDelete() >= 1
      Buffer + Comments::Section(Language::Message("The Delete map element operator(s)"), 1)
      Buffer + MapMethods::DefineDelete()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetFind() >= 1
      Buffer + Comments::Section(Language::Message("The Find map element operator(s)"), 1)
      Buffer + MapMethods::DefineFind()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetNext() >= 1
      Buffer + Comments::Section(Language::Message("The Next map element operator(s)"), 1)
      Buffer + MapMethods::DefineNext()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetKey() >= 1
      Buffer + Comments::Section(Language::Message("The map Key operator(s)"), 1)
      Buffer + MapMethods::DefineKey()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetInsert() >= 1
      Buffer + Comments::Section(Language::Message("The Insert map operator(s)"), 1)
      Buffer + MapMethods::DefineInsert()
    EndIf
    
    If General::GetIsMapPresent() And MapMethods::GetExtract() >= 1
      Buffer + Comments::Section(Language::Message("The Extract map operator(s)"), 1)
      Buffer + MapMethods::DefineExtract()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And MathsMethods::GetEqual() >= 1
      Buffer + Comments::Section(Language::Message("The Equal operator : A = B"), 1)
      Buffer + MathsMethods::DefineEqual()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And MathsMethods::GetPlus() >= 1
      Buffer + Comments::Section(Language::Message("The Plus operator : R = A + B"), 1)
      Buffer + MathsMethods::DefinePlus()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And MathsMethods::GetMinus() >= 1
      Buffer + Comments::Section(Language::Message("The Minus operator : R = A - B"), 1)
      Buffer + MathsMethods::DefineMinus()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And MathsMethods::GetProduct() >= 1
      Buffer + Comments::Section(Language::Message("The Product operator : R = A * B"), 1)
      Buffer + MathsMethods::DefineProduct()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And MathsMethods::GetDivide() >= 1
      Buffer + Comments::Section(Language::Message("The Divide operator : R = A / B"), 1)
      Buffer + MathsMethods::DefineDivide()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And MathsMethods::GetProductByScalar() >= 1
      Buffer + Comments::Section(Language::Message("The ProductByScalar operator : R = A * Scalar"), 1)
      Buffer + MathsMethods::DefineProductByScalar()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And MathsMethods::GetDivideByScalar() >= 1
      Buffer + Comments::Section(Language::Message("The DivideByScalar operator : R = A / Scalar"), 1)
      Buffer + MathsMethods::DefineDivideByScalar()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And MathsMethods::GetCopy() >= 1
      Buffer + Comments::Section(Language::Message("The Copy operator : A = Source : B = Destination"), 1)
      Buffer + MathsMethods::DefineCopy()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And MathsMethods::GetCompare() >= 1
      Buffer + Comments::Section(Language::Message("The Compare operator"), 1)
      Buffer + MathsMethods::DefineCompare()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And MathsMethods::GetSwapping() >= 1
      Buffer + Comments::Section(Language::Message("The Swapping operator"), 1)
      Buffer + MathsMethods::DefineSwapping()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And General::GetIsSquareMatrix()
      Buffer + Comments::Section(Language::Message("The Identity operator"), 1)
      Buffer + MathsMethods::DefineIdentity()
      Buffer + Comments::Section(Language::Message("The Transpose operator"), 1)
      Buffer + MathsMethods::DefineTranspose()
      Buffer + Comments::Section(Language::Message("The Determinant operator"), 1)
      Buffer + MathsMethods::DefineDeterminant()
      Buffer + Comments::Section(Language::Message("The Inverse operator"), 1)
      Buffer + MathsMethods::DefineInverse()
    EndIf
    
    If General::GetInstanceStyle() = Field::#INSTANCE_STYLE_OFF_MODULE And General::GetIsMatrix()
      Buffer + Comments::Section(Language::Message("The Random operator"), 1)
      Buffer + MathsMethods::DefineRandomize()
      Buffer + Comments::Section(Language::Message("The Format operators"), 1)
      Buffer + MathsMethods::DefineFormatLine()
      Buffer + Comments::Section(Language::Message("The Unformat operators"), 1)
      Buffer + MathsMethods::DefineUnformatLine()
    EndIf
    
    If XMLFileMethods::GetNodeWithChildNode() >= 1
      Buffer + Comments::Section(Language::Message("Set - Node with child nodes"), 1)
      Buffer + XMLFileMethods::DefineSetNode()
      Buffer + Comments::Section(Language::Message("Get - Node with child nodes"), 1) 
      Buffer + XMLFileMethods::DefineGetNode()
    EndIf
    
    If XMLFileMethods::GetNodeWithAttributes() >= 1
      Buffer + Comments::Section(Language::Message("Set - Node with attributes"), 1)  
      Buffer + XMLFileMethods::DefineSetAttributes()
      Buffer + Comments::Section(Language::Message("Get - Node with attributes"), 1)
      Buffer + XMLFileMethods::DefineGetAttributes()
    EndIf
    
    If XMLFileMethods::GetAddCollectAttributes() >= 1
      Buffer + Comments::Section(Language::Message("Add attributes to current node"), 1) 
      Buffer + XMLFileMethods::DefineAddAttributes()
      Buffer + Comments::Section(Language::Message("Collect attributes from current node"), 1) 
      Buffer + XMLFileMethods::DefineCollectAttributes()
    EndIf
    
    If XMLFileMethods::GetCreateLoadFile() >= 1
      Buffer + Comments::Section(Language::Message("Create XML file"), 1) 
      Buffer + XMLFileMethods::DefineCreateFile()  
      Buffer + Comments::Section(Language::Message("Load XML file"), 1) 
      Buffer + XMLFileMethods::DefineLoadFile()
    EndIf
    
    If XMLFileMethods::GetCatchFile() >= 1
      Buffer + Comments::Section(Language::Message("Catch XML file"), 1) 
      Buffer + XMLFileMethods::DefineCatchFile()
    EndIf
    
    If JSONFileMethods::GetCreateLoadFile() >= 1
      Buffer + Comments::Section(Language::Message("Create JSON file"), 1) 
      Buffer + JSONFileMethods::DefineCreateFile()
      Buffer + Comments::Section(Language::Message("Load JSON file"), 1) 
      Buffer + JSONFileMethods::DefineLoadFile()
    EndIf  
    
    If DataBaseMethods::GetCreateTable() >= 1
      Buffer + Comments::Section(Language::Message("Create Database table"), 1) 
      Buffer + DataBaseMethods::DefineCreateTable()
    EndIf
    
    If DataBaseMethods::GetOpenFile() >= 1 And General::GetIsDatabaseHelperNeeded() = 1
      Buffer + Comments::Section(Language::Message("Create Database table(s)"), 1) 
      Buffer + DataBaseMethods::DefineCreateTable()
    EndIf
    
    If DataBaseMethods::GetDropTable() >= 1
      Buffer + Comments::Section(Language::Message("Drop Database table"), 1) 
      Buffer + DataBaseMethods::DefineDropTable()
    EndIf
    
    If General::GetIsDatabaseHelperNeeded() = 1
      Buffer + Comments::Section(Language::Message("Drop Database table(s)"), 1) 
      Buffer + DataBaseMethods::DefineDropTable()
    EndIf 
    
    If DataBaseMethods::GetTruncateTable() >= 1
      Buffer + Comments::Section(Language::Message("Truncate Database table"), 1)
      Buffer + DataBaseMethods::DefineTruncateTable()
    EndIf
    
    If General::GetIsDatabaseHelperNeeded() = 1
      Buffer + Comments::Section(Language::Message("Truncate Database table(s)"), 1) 
      Buffer + DataBaseMethods::DefineTruncateTable()
    EndIf 
    
    If DataBaseMethods::GetSelectTable() >= 1
      Buffer + Comments::Section(Language::Message("Select Database table"), 1) 
      Buffer + DataBaseMethods::DefineSelectTable()
    EndIf
    
    If General::GetIsDatabaseHelperNeeded() = 1
      Buffer + Comments::Section(Language::Message("Select Database table(s)"), 1) 
      Buffer + DataBaseMethods::DefineSelectTable()
    EndIf
    
    If DataBaseMethods::GetCountRow() >= 1
      Buffer + Comments::Section(Language::Message("Count Row In Database table"), 1) 
      Buffer + DataBaseMethods::DefineCountRow()
    EndIf
    
    If General::GetIsDatabaseHelperNeeded() = 1
      Buffer + Comments::Section(Language::Message("Count Row In Database table(s)"), 1) 
      Buffer + DataBaseMethods::DefineCountRow()
    EndIf
    
    If General::GetIsDatabaseHelperNeeded() = 2
      Buffer + Comments::Section(Language::Message("Insert Database Table entry"), 1) 
      Buffer + DataBaseMethods::GenerateInsertDatabaseEntry()
    EndIf

    If General::GetIsDatabaseHelperNeeded() = 1
      Buffer + Comments::Section(Language::Message("Insert Database Table(s) entry"), 1) 
      Buffer + DataBaseMethods::GenerateInsertDatabaseEntry()
    EndIf
    
    If General::GetIsDatabaseHelperNeeded() = 2
      Buffer + Comments::Section(Language::Message("Update Database Table entry"), 1) 
      Buffer + DataBaseMethods::GenerateUpdateDatabaseEntry()
    EndIf 
    
    If General::GetIsDatabaseHelperNeeded() = 1
      Buffer + Comments::Section(Language::Message("Update Database Table(s) entry"), 1) 
      Buffer + DataBaseMethods::GenerateUpdateDatabaseEntry()  
    EndIf

    If General::GetIsDatabaseHelperNeeded() = 2
      Buffer + Comments::Section(Language::Message("Delete Database Table entry"), 1) 
      Buffer + DataBaseMethods::GenerateDeleteDatabaseEntry()
    EndIf
    
    If General::GetIsDatabaseHelperNeeded() = 1
      Buffer + Comments::Section(Language::Message("Delete Database Table(s) entry"), 1) 
      Buffer + DataBaseMethods::GenerateDeleteDatabaseEntry()
    EndIf
    
    If General::GetIsDatabaseHelperNeeded() = 2
      Buffer + Comments::Section(Language::Message("Extract Database Table entry"), 1) 
      Buffer + DataBaseMethods::GenerateExtractDatabaseEntry()
    EndIf
    
    If General::GetIsDatabaseHelperNeeded() = 1
      Buffer + Comments::Section(Language::Message("Extract Database Table(s) entry"), 1) 
      Buffer + DataBaseMethods::GenerateExtractDatabaseEntry() 
    EndIf
    
    If General::GetIsDatabaseHelperNeeded() = 1
      Buffer + Comments::Section(Language::Message("Transfer Database To Table(s)"), 1) 
      Buffer + DataBaseMethods::GenerateDatabase_To_Tables() 
    EndIf
    
    If General::GetIsDatabaseHelperNeeded() = 1 
      Buffer + Comments::Section(Language::Message("Transfer Table(s) To Database"), 1) 
      Buffer + DataBaseMethods::GenerateTables_To_Database() 
    EndIf

    If DataBaseMethods::GetOpenFile() >= 1
      Buffer + Comments::Section(Language::Message("Open Database"), 1) 
      Buffer + DataBaseMethods::DefineOpenFile()
    EndIf
    
    If DataBaseMethods::GetSendModuleTo() >= 1
      Buffer + Comments::Section(Language::Message("Transfer from Module to Database"), 1)
      Buffer + DataBaseMethods::DefineSendModuleTo()
    EndIf
    
    If DataBaseMethods::GetLoadModuleFrom() >= 1
      Buffer + Comments::Section(Language::Message("Transfer from Database to Module"), 1)
      Buffer + DataBaseMethods::DefineLoadModuleFrom()
    EndIf
    
    If DataBaseMethods::GetVacummize() >= 1
      Buffer + Comments::Section(Language::Message("Vacuumize Database"), 1) 
      Buffer + DataBaseMethods::DefineVacummize()
    EndIf
    
    If PrefsFileMethods::GetReadWriteGroup() >= 1
      Buffer + Comments::Section(Language::Message("Read preferences group"), 1)
      Buffer + PrefsFileMethods::DefineReadGroup()
      Buffer + Comments::Section(Language::Message("Write preferences group"), 1)
      Buffer + PrefsFileMethods::DefineWriteGroup()
    EndIf
    
    If PrefsFileMethods::GetCreateOpenFile() >= 1
      Buffer + Comments::Section(Language::Message("Create preferences file"), 1)
      Buffer + PrefsFileMethods::DefineCreateFile()
      Buffer + Comments::Section(Language::Message("Open preferences file"), 1) 
      Buffer + PrefsFileMethods::DefineOpenFile()
    EndIf
    
    If BinaryFileMethods::GetReadWrite() >= 1
      Buffer + Comments::Section(Language::Message("Read in Binary file"), 1)
      Buffer + BinaryFileMethods::DefineRead()
      Buffer + Comments::Section(Language::Message("Write in Binary file"), 1) 
      Buffer + BinaryFileMethods::DefineWrite()
    EndIf
    
    If BinaryFileMethods::GetCreateFile() >= 1
      Buffer + Comments::Section(Language::Message("Create Binary File"), 1)
      Buffer + BinaryFileMethods::DefineCreateFile()
    EndIf
    
    If BinaryFileMethods::GetOpenFile() >= 1
      Buffer + Comments::Section(Language::Message("Open Binary File"), 1)
      Buffer + BinaryFileMethods::DefineOpenFile()
    EndIf
    
    If BinaryFileMethods::GetReadFile() >= 1
      Buffer + Comments::Section(Language::Message("Read Binary File"), 1)
      Buffer + BinaryFileMethods::DefineReadFile()
    EndIf
    
    If EncodedFileMethods::GetReadWrite() >= 1
      Buffer + Comments::Section(Language::Message("Read in Encoded file"), 1)
      Buffer + EncodedFileMethods::DefineRead()
      Buffer + Comments::Section(Language::Message("Write in Encoded file"), 1) 
      Buffer + EncodedFileMethods::DefineWrite()
    EndIf
    
    If EncodedFileMethods::GetCreateFile() >= 1
      Buffer + Comments::Section(Language::Message("Create Encoded File"), 1)
      Buffer + EncodedFileMethods::DefineCreateFile()
    EndIf
    
    If EncodedFileMethods::GetOpenFile() >= 1
      Buffer + Comments::Section(Language::Message("Open Encoded File"), 1)
      Buffer + EncodedFileMethods::DefineOpenFile()
    EndIf
    
    If EncodedFileMethods::GetReadFile() >= 1
      Buffer + Comments::Section(Language::Message("Read Encoded File"), 1)
      Buffer + EncodedFileMethods::DefineReadFile()
    EndIf
    
    If CryptedFileMethods::GetReadWrite() >= 1
      Buffer + Comments::Section(Language::Message("Read in Crypted file"), 1)
      Buffer + CryptedFileMethods::DefineRead()
      Buffer + Comments::Section(Language::Message("Write in Crypted file"), 1) 
      Buffer + CryptedFileMethods::DefineWrite()
    EndIf
    
    If CryptedFileMethods::GetCreateFile() >= 1
      Buffer + Comments::Section(Language::Message("Create Crypted File"), 1)
      Buffer + CryptedFileMethods::DefineCreateFile()
    EndIf
    
    If CryptedFileMethods::GetOpenFile() >= 1
      Buffer + Comments::Section(Language::Message("Open Crypted File"), 1)
      Buffer + CryptedFileMethods::DefineOpenFile()
    EndIf
    
    If CryptedFileMethods::GetReadFile() >= 1
      Buffer + Comments::Section(Language::Message("Read Crypted File"), 1)
      Buffer + CryptedFileMethods::DefineReadFile()
    EndIf
    
    If DebuggingMethods::GetDebugging() >= 1
      Buffer + Comments::Section(Language::Message("The Debugging Operator"), 1)
      Buffer + DebuggingMethods::DefineDebugging()
    EndIf
    
    Buffer + "EndModule" + LineFeed::Twin()
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure.s Generate(Flag.b = 0)
    
    Select Flag
        
      Case 0
       
        Field::GenerateParamList()
        
        Chrono::New(0)
        Chrono::Start(0)
        
        Buffer.s = Comments::SourceHeader() + DeclarePublicProcedureCode() + ModuleDefinitionCode()
        
        Chrono::Stop(0)
        
        If Chrono::Consult(0) = 0
          Chrono::Start(0)
          Delay(1)
          Chrono::Stop(0)
        EndIf
        
        Buffer + Comments::WorkingTime(Buffer) + Comments::EndOfFile()
        
        Field::Reset(Field::#RESET_STYLE_AFTER_RUN)
        
      Case 1
        
        Chrono::New(0)
        Chrono::Start(0)
        
        Buffer + Comments::SourceHeader() + MatrixEncodedGenerator::GenerateSource()
        
        Chrono::Stop(0)
        
        If Chrono::Consult(0) = 0
          Chrono::Start(0)
          Delay(1)
          Chrono::Stop(0)
        EndIf
        
        Buffer + Comments::WorkingTime(Buffer) + Comments::EndOfFile()
        MatrixEncodedGenerator::Reset()

    EndSelect
    
    ProcedureReturn Buffer
  EndProcedure
  
  Procedure SaveProjectFile(FileName.s)
    
    If CreatePreferences(FileName)
      
      Field::SaveProjectFile()
      BasicMethods::WritePrefs("BasicMethods")
      StaticArrayMethods::WritePrefs("StaticArrayMethods")
      LinkedListMethods::WritePrefs("LinkedListMethods")
      DynamicArrayMethods::WritePrefs("DynamicArrayMethods")
      MathsMethods::WritePrefs("MathsMethods")
      XMLFileMethods::WritePrefs("XMLFileMethods")
      JSONFileMethods::WritePrefs("JSONFileMethods")
      DataBaseMethods::WritePrefs("DataBaseMethods")
      PrefsFileMethods::WritePrefs("PrefsFileMethods")
      BinaryFileMethods::WritePrefs("BinaryFileMethods")
      EncodedFileMethods::WritePrefs("EncodedFileMethods")
      CryptedFileMethods::WritePrefs("CryptedFileMethods")
      
      ClosePreferences()
      
    EndIf
    
  EndProcedure
  
  Procedure LoadProjectFile(FileName.s)
    
    If OpenPreferences(FileName)

      Field::LoadProjectFile() 
      BasicMethods::ReadPrefs("BasicMethods")
      StaticArrayMethods::ReadPrefs("StaticArrayMethods")
      LinkedListMethods::ReadPrefs("LinkedListMethods")
      DynamicArrayMethods::ReadPrefs("DynamicArrayMethods")
      MathsMethods::ReadPrefs("MathsMethods")
      XMLFileMethods::ReadPrefs("XMLFileMethods")
      JSONFileMethods::ReadPrefs("JSONFileMethods")
      DataBaseMethods::ReadPrefs("DataBaseMethods")
      PrefsFileMethods::ReadPrefs("PrefsFileMethods")
      BinaryFileMethods::ReadPrefs("BinaryFileMethods")
      EncodedFileMethods::ReadPrefs("EncodedFileMethods")
      CryptedFileMethods::ReadPrefs("CryptedFileMethods")
      
      ClosePreferences()

    EndIf
    
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 LTS (Linux - x64)
; Folding = f+
; EnableXP
; CompileSourceDirectory