; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Dev-Module
; Nom du fichier : DevModule - Comments.pb
; Version du fichier : 0.9.1
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 03-10-2014
; Mise  jour : 10-03-2019
; Code PureBasic : V5.70 LTS
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Comments
  
  Declare.s GetUserName()
  Declare.s GetUserNickName()
  Declare.s GetUserEmail()
  Declare.s GetPureBasicVersion()
  Declare.s GetProgramVersion()
  Declare.b GetTabSizeMin()
  Declare.b GetTabSizeMax()
  Declare.b GetTabSize()
  Declare.b GetTabOption()
  Declare.s GetDateMaskEx()
  Declare.l GetSelectedDateMask()
  
  Declare SetUserName(P_UserName.s)
  Declare SetUserNickName(P_UserNickName.s)
  Declare SetUserEmail(P_UserEmail.s)
  Declare SetPureBasicVersion(P_PureBasicVersion.s)
  Declare SetProgramVersion(P_ProgramVersion.s)
  Declare SetTabSizeMin(P_TabSizeMin.b)
  Declare SetTabSizeMax(P_TabSizeMax.b)
  Declare SetTabSize(P_TabSize.b)
  Declare SetTabOption(P_TabOption.b)
  
  Declare SelectDateMask(P_Index.l)
  Declare FirstDateMask()
  Declare LastDateMask()
  Declare PreviousDateMask()
  Declare NextDateMask()
  Declare DeleteDateMask()
  Declare ResetDateMask()
  Declare ClearDateMask()
  Declare DateMaskIndex()
  Declare DateMaskSize()
  
  Declare Initialize(P_ProgramVersion.s)
  Declare Reset()
  Declare RefreshHeader()

  Declare AddDateMask(P_DateMask.s)
  Declare RemoveDateMask(P_DateMaskID.l)
  Declare SelectDateMask(P_DateMaskID.l)
 
  Declare WritePrefs(GroupName.s)
  Declare ReadPrefs(GroupName.s)
  
  Declare.s Tabulation(Length.b)
  Declare.s SourceHeader()
  Declare.s Section(Message.s, TabSize.l)
  Declare.s WorkingTime(Buffer.s)
  Declare.s EndOfFile()
  Declare.b GetTabSize()
  
EndDeclareModule

Module Comments
  
  Enumeration
    
    #HEADER_AUTOGENERATED_CODE00
    #HEADER_AUTOGENERATED_CODE01
    #HEADER_GENERATED_BY
    #HEADER_PROJECT_NAME
    #HEADER_FILE_NAME
    #HEADER_FILE_VERSION
    #HEADER_PROGRAMMATION_STATE
    #HEADER_PROGRAMMER_NAME
    #HEADER_PROGRAMMER_NICKNAME
    #HEADER_PROGRAMMER_EMAIL
    #HEADER_CREATION_DATE
    #HEADER_MODIFICATION_DATE
    #HEADER_PUREBASIC_VERSION
    #HEADER_PLATFORM
    
    #HEADER_MAX
    
  EndEnumeration
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration des Structures <<<<<

  Structure Instance

    UserName.s
    UserNickName.s
    UserEmail.s
    PureBasicVersion.s
    ProgramVersion.s
    TabSizeMin.b
    TabSizeMax.b
    TabSize.b
    TabOption.b
    Header.s[#HEADER_MAX]
    HeaderLenMax.l
    SelectedDateMask.l
    List DateMask.s()

  EndStructure

  Global Instance.Instance
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les observateurs <<<<<

  Procedure.s GetUserName()

    ProcedureReturn Instance\UserName
  EndProcedure

  Procedure.s GetUserNickName()

    ProcedureReturn Instance\UserNickName
  EndProcedure

  Procedure.s GetUserEmail()

    ProcedureReturn Instance\UserEmail
  EndProcedure

  Procedure.s GetPureBasicVersion()

    ProcedureReturn Instance\PureBasicVersion
  EndProcedure

  Procedure.s GetProgramVersion()

    ProcedureReturn Instance\ProgramVersion
  EndProcedure

  Procedure.b GetTabSizeMin()

    ProcedureReturn Instance\TabSizeMin
  EndProcedure

  Procedure.b GetTabSizeMax()

    ProcedureReturn Instance\TabSizeMax
  EndProcedure

  Procedure.b GetTabSize()

    ProcedureReturn Instance\TabSize
  EndProcedure

  Procedure.b GetTabOption()

    ProcedureReturn Instance\TabOption
  EndProcedure
  
  Procedure.s GetDateMaskEx()

    ProcedureReturn Instance\DateMask()
  EndProcedure
  
  Procedure.l GetSelectedDateMask()
  
    ProcedureReturn Instance\SelectedDateMask
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateurs <<<<<

  Procedure SetUserName(P_UserName.s)

    Instance\UserName = P_UserName

  EndProcedure

  Procedure SetUserNickName(P_UserNickName.s)

    Instance\UserNickName = P_UserNickName

  EndProcedure

  Procedure SetUserEmail(P_UserEmail.s)

    Instance\UserEmail = P_UserEmail

  EndProcedure

  Procedure SetPureBasicVersion(P_PureBasicVersion.s)

    Instance\PureBasicVersion = P_PureBasicVersion

  EndProcedure

  Procedure SetProgramVersion(P_ProgramVersion.s)

    Instance\ProgramVersion = P_ProgramVersion

  EndProcedure

  Procedure SetTabSizeMin(P_TabSizeMin.b)

    Instance\TabSizeMin = P_TabSizeMin

  EndProcedure

  Procedure SetTabSizeMax(P_TabSizeMax.b)

    Instance\TabSizeMax = P_TabSizeMax

  EndProcedure

  Procedure SetTabSize(P_TabSize.b)

    Instance\TabSize = P_TabSize

  EndProcedure

  Procedure SetTabOption(P_TabOption.b)

    Instance\TabOption = P_TabOption

  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'operateur(s) Premier lment de la liste chane <<<<<

  Procedure FirstDateMask()

    ProcedureReturn FirstElement(Instance\DateMask())
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'operateur(s) Dernier lment de la liste chane <<<<<

  Procedure LastDateMask()

    ProcedureReturn LastElement(Instance\DateMask())
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'operateur(s) lment Prcdent de la liste chane <<<<<

  Procedure PreviousDateMask()

    ProcedureReturn PreviousElement(Instance\DateMask())
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'operateur(s) lment Suivant de la liste chane <<<<<

  Procedure NextDateMask()

    ProcedureReturn NextElement(Instance\DateMask())
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'operateur(s) Supprimer l'lment courant de la liste chane <<<<<

  Procedure DeleteDateMask()

    DeleteElement(Instance\DateMask())

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'operateur(s) Reset de la liste chane <<<<<

  Procedure ResetDateMask()

    ResetList(Instance\DateMask())

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'operateur(s) Clear de la liste chane <<<<<

  Procedure ClearDateMask()

    ClearList(Instance\DateMask())

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'operateur(s) de numro d'index de la liste chane <<<<<

  Procedure DateMaskIndex()

    ProcedureReturn ListIndex(Instance\DateMask())
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'operateur(s) de grandeur de la liste chane <<<<<

  Procedure DateMaskSize()

    ProcedureReturn ListSize(Instance\DateMask())
  EndProcedure
 
  Procedure RefreshHeader()

    Instance\Header[#HEADER_AUTOGENERATED_CODE00] = Language::Message("AUTOMATICALLY GENERATED CODE, DO NOT MODIFY")
    Instance\Header[#HEADER_AUTOGENERATED_CODE01] = Language::Message("UNLESS YOU REALLY, REALLY, REALLY MEAN IT !!")
    Instance\Header[#HEADER_GENERATED_BY] = Language::Message("Code generated by :") + " " + Language::Message("Dev-Module")
    Instance\Header[#HEADER_PROJECT_NAME] = Language::Message("Project name : the project name here")
    Instance\Header[#HEADER_FILE_NAME] = Language::Message("File name : File name here")
    Instance\Header[#HEADER_FILE_VERSION] = Language::Message("File Version : 0.0.0")
    Instance\Header[#HEADER_PROGRAMMATION_STATE] = Language::Message("Programmation : In progress")
    Instance\Header[#HEADER_PROGRAMMER_NAME] = Language::Message("Programmed by :") + " "
    Instance\Header[#HEADER_PROGRAMMER_NICKNAME] = Language::Message("AKA :") + " "
    Instance\Header[#HEADER_PROGRAMMER_EMAIL] = Language::Message("E-mail :") + " "
    Instance\Header[#HEADER_CREATION_DATE] = Language::Message("Creation Date :") + " "
    Instance\Header[#HEADER_MODIFICATION_DATE] = Language::Message("Last update :") + " "
    Instance\Header[#HEADER_PUREBASIC_VERSION] = Language::Message("Coded for PureBasic :") + " V"
    Instance\Header[#HEADER_PLATFORM] = Language::Message("Platform : Windows, Linux, MacOS X")
    
    For LineID = #HEADER_AUTOGENERATED_CODE00 To #HEADER_MAX - 1
      Instance\HeaderLenMax = Max::Long(Instance\HeaderLenMax, Len(Instance\Header[LineID]))
    Next
    
  EndProcedure
  
  Procedure AddDateMask(P_DateMask.s)
    
    If P_DateMask <> ""
      
      IsFoundAtIndex.l = -1
      
      ForEach Instance\DateMask()
        
        If Instance\DateMask() = P_DateMask
          IsFoundAtIndex = ListIndex(Instance\DateMask())
          Break
        EndIf
        
      Next
      
      If IsFoundAtIndex = -1
        AddElement(Instance\DateMask())
        Instance\DateMask() = P_DateMask
        Instance\SelectedDateMask = ListIndex(Instance\DateMask())
      EndIf
      
    EndIf
    
  EndProcedure
  
  Procedure RemoveDateMask(P_DateMaskID.l)
    
    If SelectElement(Instance\DateMask(), P_DateMaskID)
      DeleteElement(Instance\DateMask(), 1)
      Instance\SelectedDateMask = ListIndex(Instance\DateMask())
    EndIf
    
  EndProcedure
  
  Procedure SelectDateMask(P_DateMaskID.l)
    
    If P_DateMaskID < 0
      P_DateMaskID = 0
    ElseIf P_DateMaskID >= ListSize(Instance\DateMask())
      P_DateMaskID = ListSize(Instance\DateMask()) - 1
    EndIf
    
    Instance\SelectedDateMask = P_DateMaskID
    
    If Instance\SelectedDateMask = -1
      Instance\SelectedDateMask = 0
    EndIf

    SelectElement(Instance\DateMask(), Instance\SelectedDateMask)
        
  EndProcedure
 
  Procedure Initialize(P_ProgramVersion.s)
    
    Instance\UserName = "Your name"
    Instance\UserNickName = "Nick name"
    Instance\UserEmail = "Email"
    Instance\TabSizeMin = 1
    Instance\TabSizeMax = 5
    Instance\TabSize = 2
    Instance\TabOption = 0
    Instance\PureBasicVersion = AskPureBasicCompiler::CurrentVersion()
    Instance\ProgramVersion = P_ProgramVersion
    
  EndProcedure
  
  Procedure Reset()
    
    Instance\UserName = ""
    Instance\UserNickName = ""
    Instance\UserEmail = ""
    Instance\PureBasicVersion = ""
    Instance\ProgramVersion = ""
    Instance\TabSizeMin = 0
    Instance\TabSizeMax = 0
    Instance\TabSize = 0
    Instance\TabOption = 0
    
    For HeaderID = 0 To #HEADER_MAX - 1
      Instance\Header[HeaderID] = ""
    Next
    
    Instance\HeaderLenMax = 0
    Instance\SelectedDateMask = 0
    
    ForEach Instance\DateMask()
      Instance\DateMask() = ""
    Next

    FreeList(Instance\DateMask())
    
  EndProcedure
  
  Procedure WritePrefs(GroupName.s)
    
    PreferenceGroup(GroupName)
    
    WritePreferenceString("UserName", Instance\UserName)
    WritePreferenceString("UserNickName", Instance\UserNickName)
    WritePreferenceString("UserEmail", Instance\UserEmail)
    WritePreferenceLong("TabSize", Instance\TabSize)
    WritePreferenceLong("TabOption", Instance\TabOption)
    
    WritePreferenceLong("DateMask_Max", ListSize(Instance\DateMask()))
    
    ForEach Instance\DateMask()
      WritePreferenceString("DateMask_" + Str(ListIndex(Instance\DateMask())), Instance\DateMask())
    Next
    
    WritePreferenceLong("SelectedDateMask", Instance\SelectedDateMask)
    
  EndProcedure
  
  Procedure ReadPrefs(GroupName.s)

    PreferenceGroup(GroupName)
    
    Instance\UserName = ReadPreferenceString("UserName", Instance\UserName)
    Instance\UserNickName = ReadPreferenceString("UserNickName", Instance\UserNickName)
    Instance\UserEmail = ReadPreferenceString("UserEmail", Instance\UserEmail)
    Instance\TabSize = ReadPreferenceLong("TabSize", Instance\TabSize)
    Instance\TabOption = ReadPreferenceLong("TabOption", Instance\TabOption)
   
    DateMask_Max = ReadPreferenceLong("DateMask_Max", 0)
    
    If DateMask_Max = 0 
      AddDateMask("%dd-%mm-%yyyy")
      Instance\SelectedDateMask = 0
    Else
      
      For DateMaskID = 0 To DateMask_Max - 1
        AddDateMask(ReadPreferenceString("DateMask_" + Str(DateMaskID), "%dd-%mm-%yyyy"))
      Next
      
    EndIf 
    
    SelectDateMask(ReadPreferenceLong("SelectedDateMask", Instance\SelectedDateMask))
    
  EndProcedure
  
  Procedure.s SourceHeader()
    
    SelectElement(Instance\DateMask(), Instance\SelectedDateMask)
    
    Separation.s = LSet("; ", Instance\HeaderLenMax + 7, "<")
    
    Buffer.s + Separation + LineFeed::Single()
    
    For LineID = #HEADER_AUTOGENERATED_CODE00 To #HEADER_AUTOGENERATED_CODE01
      Buffer + "; " + UCase(Instance\Header[LineID]) + LineFeed::Single()
    Next
    
    Buffer + Separation + LineFeed::Single()
    
    For LineID = #HEADER_GENERATED_BY To #HEADER_PLATFORM
      
      Select LineID
          
        Case #HEADER_GENERATED_BY
          Buffer + "; " + Instance\Header[LineID] + Instance\ProgramVersion + LineFeed::Single()
          
        Case #HEADER_PROGRAMMER_NAME
          Buffer + "; " + Instance\Header[LineID] + Instance\UserName + LineFeed::Single()
          
        Case #HEADER_PROGRAMMER_NICKNAME
          Buffer + "; " + Instance\Header[LineID] + Instance\UserNickName + LineFeed::Single()
          
        Case #HEADER_PROGRAMMER_EMAIL
          Buffer + "; " + Instance\Header[LineID] + Instance\UserEmail + LineFeed::Single()
          
        Case #HEADER_CREATION_DATE, #HEADER_MODIFICATION_DATE
          Buffer + "; " + Instance\Header[LineID] + AdvancedDateFormatting::Format(Instance\DateMask(), Date()) + LineFeed::Single()
          
        Case #HEADER_PUREBASIC_VERSION
          Buffer + "; " + Instance\Header[LineID] + Instance\PureBasicVersion + LineFeed::Single()
          
        Default
          Buffer + "; " + Instance\Header[LineID] + LineFeed::Single()
          
      EndSelect
      
    Next
    
    ProcedureReturn Buffer + Separation + LineFeed::Twin()
  EndProcedure
  
  Procedure.s Tabulation(Length.b)
    
    If Instance\TabOption = 0
      Length = Length * Instance\TabSize
      Character.s = Chr(32)
    Else
      Character = Chr(9)
    EndIf
    
    ProcedureReturn LSet("", Length, Character)
  EndProcedure
  
  Procedure.s Section(Message.s, TabSize.l)
    
    Commentaire.s = "; <<<<< " + Message + " <<<<<"
    
    ProcedureReturn Tabulation(TabSize) + LSet("; ", Len(Commentaire), "<") + LineFeed::Single() + Tabulation(TabSize) + Commentaire + LineFeed::Twin()
  EndProcedure

  Procedure.s WorkingTime(Buffer.s)
    
    LineCount = CountString(Buffer, LineFeed::Single())
    Taux.d = LineCount / (Chrono::Consult(0) / 1000.0)
    
    Stats::InsertTopBottomOutRatesTimes(Taux, Chrono::Consult(0))
    Commentaire.s = "; <<<<< " + ReplaceString(ReplaceString(Language::Message("Code generated in : %TIME% seconds (%RATE% lines/second)"), "%TIME%", Chrono::Format(0, "%ss.%mss")), "%RATE%", StrD(Taux,2)) + " <<<<<"
    Seperator.s = LSet("; ", Len(Commentaire), "<")

    ProcedureReturn Seperator + LineFeed::Single() + Commentaire + LineFeed::Single() + Seperator + LineFeed::Twin()
  EndProcedure
  
  Procedure.s EndOfFile()
    
    Comment.s = "; <<<<< " + Language::Message("END OF FILE") + " <<<<<"
    Separator.s = LSet("; ", Len(Comment), "<") 
    
    ProcedureReturn Separator + LineFeed::Single() + UCase(Comment) + LineFeed::Single() + Separator
  EndProcedure

EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 LTS (Linux - x64)
; Folding = --------
; EnableXP
; CompileSourceDirectory