; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Levenshtein distance
; Rference : ; http://en.wikipedia.org/wiki/Levenshtein_distance
; Nom du Fichier : Levenshtein - Module.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 01-03-2009
; Mise  jour : 24-02-2015
; Cod avec PureBasic V5.31
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Levenshtein
  
  Declare.l Distance(P_String01.s, P_String02.s, P_CaseSensitive.b = #False) 
  Declare.d Correlation(P_String01.s, P_String02.s, P_CaseSensitive.b = #False)
  
EndDeclareModule

Module Levenshtein
  
  Procedure.l Distance(P_String01.s, P_String02.s, P_CaseSensitive.b = #False)
    
    If P_CaseSensitive = #False
      P_String01 = LCase(P_String01)
      P_String02 = LCase(P_String02)
    EndIf
    
    m.l = Len(P_String01)
    n.l = Len(P_String02)
    
    Dim StringDistance.l(m, n)
    
    For Index = 0 To m
      StringDistance(Index, 0) = Index
    Next
    
    For Index = 0 To n
      StringDistance(0, Index) = Index
    Next
    
    For IndexA = 1 To m
      For IndexB = 1 To n
        
        If Mid(P_String01, IndexA - 1, 1) = Mid(P_String02, IndexB - 1, 1)
          cost = 0
        Else
          cost = 1
        EndIf   
        
        Smallest_Long.l = StringDistance(IndexA - 1, IndexB) + 1
        Min02.l = StringDistance(IndexA, IndexB - 1) + 1
        Min03.l = StringDistance(IndexA - 1, IndexB - 1) + cost
        
        If Min02 < Smallest_Long
          Smallest_Long = Min02
        EndIf
        
        If Min03 < Smallest_Long
          Smallest_Long = Min03
        EndIf
        
        StringDistance(IndexA, IndexB) = Smallest_Long
        
      Next
      
    Next  
    
    ProcedureReturn StringDistance(m, n)
  EndProcedure
  
  Procedure.d Correlation(P_String01.s, P_String02.s, P_CaseSensitive.b = #False)
    
    Biggest_Long.l = Len(P_String01)
    P_Number02.l = Len(P_String02)
    
    If P_Number02 > Biggest_Long
      Biggest_Long = P_Number02
    EndIf
    
    ProcedureReturn 1.0 - Distance(P_String01, P_String02, P_CaseSensitive) / Biggest_Long
  EndProcedure
  
EndModule

CompilerIf #PB_Compiler_IsMainFile
  
  Debug Levenshtein::Distance("PrefFileName.s", "PatatePoils.s")
  Debug Levenshtein::Correlation("PrefFileName.s", "PatatePoils.s")
  Debug ""
  
  Debug Levenshtein::Distance("PrefFileName.s", "PrefsFileName.s")
  Debug Levenshtein::Correlation("PrefFileName.s", "PrefsFileName.s")
  Debug ""
  
  Debug Levenshtein::Distance("PrefFileName.s", "PrefFile.s")
  Debug Levenshtein::Correlation("PrefFileName.s", "PrefFile.s")
  Debug ""
  
  Debug Levenshtein::Distance("PrefFileName.s", "FileName.s")
  Debug Levenshtein::Correlation("PrefFileName.s", "FileName.s")
  Debug ""
  
CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.62 (Linux - x64)
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableUnicode