; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Vector3 Module
; Nom du fichier : Vector3 - Module.pb
; Version du fichier : 0.0.0
; Programmation : En cours
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 06-08-2007
; Mise  jour : 02-03-2015
; Code PureBasic : V5.31
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Vector3
  
  Structure Vector3
    i.d
    j.d
    k.d
  EndStructure
  
  Declare.d GetI(*VectorA.Vector3)
  Declare.d GetJ(*VectorA.Vector3)
  Declare.d GetK(*VectorA.Vector3)
  Declare SetI(*VectorA.Vector3, P_i.d)
  Declare SetJ(*VectorA.Vector3, P_j.d)
  Declare SetK(*VectorA.Vector3, P_k.d)
  Declare Update(*VectorA.Vector3, P_i.d, P_j.d, P_k.d)
  Declare Reset(*VectorA.Vector3)
  Declare Copy(*VectorA.Vector3, *VectorB.Vector3)
  Declare Compare(*VectorA.Vector3, *VectorB.Vector3)
  Declare Swapping(*VectorA.Vector3, *VectorB.Vector3)
  Declare Plus(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
  Declare Minus(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
  Declare Zero(*VectorA.Vector3)
  Declare One(*VectorA.Vector3)
  Declare ProductByScalar(*VectorR.Vector3, *VectorA.Vector3, Scalar.d)
  Declare DivideByScalar(*VectorR.Vector3, *VectorA.Vector3, Scalar.d)
  Declare ReadVector3(FileID, *VectorA.Vector3)
  Declare WriteVector3(FileID, *VectorA.Vector3)
  Declare.s Format(*VectorA.Vector3, Decimal.b = 3, Brackets.s = "[]", Separator.s = ", ")
  Declare Unformat(*VectorA.Vector3, P_Vector3.s, Brackets.s = "[]", Separator.s = ", ")
  Declare.d DotProduct(*VectorA.Vector3, *VectorB.Vector3)
  Declare.d Modulus(*VectorA.Vector3)
  Declare.d SquareModulus(*VectorA.Vector3)
  Declare.d Distance(*VectorA.Vector3, *VectorB.Vector3) 
  Declare CrossProduct(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
  Declare MedianPosition(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
  Declare Lerp(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3, P_t.d)
  Declare Add(*VectorR.Vector3, *VectorA.Vector3)
  Declare Substract(*VectorR.Vector3, *VectorA.Vector3)
  Declare AddScaled(*VectorR.Vector3, *VectorA.Vector3, Scale.d)
  Declare Unit(*VectorR.Vector3, *VectorA.Vector3 = #Null)
  Declare DefaultLocalAxis(*X_Axis.Vector3, *Y_Axis.Vector3, *Z_Axis.Vector3)
  Declare AimingPoint(*Amaing.Vector3, *Position.Vector3, *Direction.Vector3, Distance.d)
  Declare Turncate(*VectorA.Vector3, MaxLength.d)
  
EndDeclareModule

Module Vector3
  
  Procedure.d GetI(*VectorA.Vector3)
    
    ProcedureReturn *VectorA\i
  EndProcedure
  
  Procedure.d GetJ(*VectorA.Vector3)
    
    ProcedureReturn *VectorA\j
  EndProcedure
  
  Procedure.d GetK(*VectorA.Vector3)
    
    ProcedureReturn *VectorA\k
  EndProcedure
  
  Procedure SetI(*VectorA.Vector3, P_i.d)
    
    *VectorA\i = P_i
    
  EndProcedure
  
  Procedure SetJ(*VectorA.Vector3, P_j.d)
    
    *VectorA\j = P_j
    
  EndProcedure
  
  Procedure SetK(*VectorA.Vector3, P_k.d)
    
    *VectorA\k = P_k
    
  EndProcedure
  
  Procedure Update(*VectorA.Vector3, P_i.d, P_j.d, P_k.d)
    
    *VectorA\i = P_i
    *VectorA\j = P_j
    *VectorA\k = P_k
    
  EndProcedure
  
  Procedure Reset(*VectorA.Vector3)
    
    *VectorA\i = 0.0
    *VectorA\j = 0.0
    *VectorA\k = 0.0
    
  EndProcedure
  
  Procedure Copy(*VectorA.Vector3, *VectorB.Vector3)
    
    *VectorB\i = *VectorA\i
    *VectorB\j = *VectorA\j
    *VectorB\k = *VectorA\k
    
  EndProcedure
  
  Procedure Compare(*VectorA.Vector3, *VectorB.Vector3)
    
    ProcedureReturn CompareMemory(*VectorA, *VectorB, SizeOf(Vector3))
  EndProcedure
  
  Procedure Swapping(*VectorA.Vector3, *VectorB.Vector3)
    
    Swap *VectorA\i, *VectorB\i
    Swap *VectorA\j, *VectorB\j
    Swap *VectorA\k, *VectorB\k
    
  EndProcedure
  
  Procedure Plus(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
    
    *VectorR\i = *VectorA\i + *VectorB\i
    *VectorR\j = *VectorA\j + *VectorB\j
    *VectorR\k = *VectorA\k + *VectorB\k
    
  EndProcedure
  
  Procedure PlusEx(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3, *VectorC.Vector3)
    
    *VectorR\i = *VectorA\i + *VectorB\i + *VectorC\i
    *VectorR\j = *VectorA\j + *VectorB\j + *VectorC\j
    *VectorR\k = *VectorA\k + *VectorB\k + *VectorC\k
    
  EndProcedure
  
  Procedure Minus(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
    
    *VectorR\i = *VectorA\i - *VectorB\i
    *VectorR\j = *VectorA\j - *VectorB\j
    *VectorR\k = *VectorA\k - *VectorB\k
    
  EndProcedure
  
  Procedure MinusEx(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3, *VectorC.Vector3)
    
    *VectorR\i = *VectorA\i - *VectorB\i - *VectorC\i
    *VectorR\j = *VectorA\j - *VectorB\j - *VectorC\j
    *VectorR\k = *VectorA\k - *VectorB\k - *VectorC\k
    
  EndProcedure
  
  Procedure Zero(*VectorA.Vector3)
    
    *VectorA\i = 0.0
    *VectorA\j = 0.0
    *VectorA\k = 0.0
    
  EndProcedure
  
  Procedure One(*VectorA.Vector3)
    
    *VectorA\i = 1.0
    *VectorA\j = 1.0
    *VectorA\k = 1.0
    
  EndProcedure
   
  Procedure ProductByScalar(*VectorR.Vector3, *VectorA.Vector3, Scalar.d)
    
    *VectorR\i = *VectorA\i * Scalar
    *VectorR\j = *VectorA\j * Scalar
    *VectorR\k = *VectorA\k * Scalar
    
  EndProcedure
  
  Procedure DivideByScalar(*VectorR.Vector3, *VectorA.Vector3, Scalar.d)
    
    *VectorR\i = *VectorA\i / Scalar
    *VectorR\j = *VectorA\j / Scalar
    *VectorR\k = *VectorA\k / Scalar
    
  EndProcedure
  
  Procedure ReadVector3(FileID, *VectorA.Vector3)
    
    *VectorA\i = ReadDouble(FileID)
    *VectorA\j = ReadDouble(FileID)
    *VectorA\k = ReadDouble(FileID)
    
  EndProcedure
  
  Procedure WriteVector3(FileID, *VectorA.Vector3)
    
    WriteDouble(FileID, *VectorA\i)
    WriteDouble(FileID, *VectorA\j)
    WriteDouble(FileID, *VectorA\k)
    
  EndProcedure
  
  Procedure.s Format(*VectorA.Vector3, Decimal.b = 3, Brackets.s = "[]", Separator.s = ", ")
    
    ProcedureReturn Mid(Brackets,1,1) + StrD(*VectorA\i, Decimal) + Separator + StrD(*VectorA\j, Decimal) + Separator + StrD(*VectorA\k, Decimal) + Mid(Brackets,2,1)
  EndProcedure
  
  Procedure Unformat(*VectorA.Vector3, P_Vector3.s, Brackets.s = "[]", Separator.s = ", ")
    
    *VectorA\i = ValD(StringField(StringField(StringField(P_Vector3, 2, Mid(Brackets,1,1)), 1, Mid(Brackets,2,1)), 1, Separator))
    *VectorA\j = ValD(StringField(StringField(StringField(P_Vector3, 2, Mid(Brackets,1,1)), 1, Mid(Brackets,2,1)), 2, Separator))
    *VectorA\k = ValD(StringField(StringField(StringField(P_Vector3, 2, Mid(Brackets,1,1)), 1, Mid(Brackets,2,1)), 2, Separator))
    
  EndProcedure
  
  Procedure.d DotProduct(*VectorA.Vector3, *VectorB.Vector3)
    
    ProcedureReturn *VectorA\i * *VectorB\i + *VectorA\j * *VectorB\j + *VectorA\k * *VectorB\k
  EndProcedure
  
  Procedure.d Modulus(*VectorA.Vector3)
    
    ProcedureReturn Sqr(*VectorA\i * *VectorA\i + *VectorA\j * *VectorA\j + *VectorA\k * *VectorA\k)
  EndProcedure
  
  Procedure.d SquareModulus(*VectorA.Vector3)
    
    ProcedureReturn *VectorA\i * *VectorA\i + *VectorA\j * *VectorA\j + *VectorA\k * *VectorA\k
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Nom de la procdure <<<<<
  
  Procedure.d Distance(*VectorA.Vector3, *VectorB.Vector3) 
    
    X.d = *VectorB\i - *VectorA\i
    Y.d = *VectorB\j - *VectorA\j
    Z.d = *VectorB\k - *VectorA\k
    
     ProcedureReturn Sqr(X*X + Y*Y + Z*Z)
  EndProcedure

  Procedure CrossProduct(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
    
    *VectorR\i = *VectorA\j * *VectorB\k - *VectorA\k * *VectorB\j
    *VectorR\j = *VectorA\k * *VectorB\i - *VectorA\i * *VectorB\k
    *VectorR\k = *VectorA\i * *VectorB\j - *VectorA\j * *VectorB\i
    
  EndProcedure
 
  Procedure MedianPosition(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
    
    *VectorR\i = (*VectorA\i + *VectorB\i) / 2.0
    *VectorR\j = (*VectorA\j + *VectorB\j) / 2.0
    *VectorR\k = (*VectorA\k + *VectorB\k) / 2.0
    
  EndProcedure
  
  Procedure Lerp(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3, P_t.d)
    
    *VectorR\i = *VectorA\i + P_t * (*VectorB\i - *VectorA\i) 
    *VectorR\j = *VectorA\j + P_t * (*VectorB\j - *VectorA\j)
    *VectorR\k = *VectorA\k + P_t * (*VectorB\k - *VectorA\k)
    
  EndProcedure
  
  Procedure Add(*VectorR.Vector3, *VectorA.Vector3)
    
    *VectorR\i = *VectorR\i + *VectorA\i
    *VectorR\j = *VectorR\j + *VectorA\j
    *VectorR\k = *VectorR\k + *VectorA\k
    
  EndProcedure
  
  Procedure Substract(*VectorR.Vector3, *VectorA.Vector3)
    
    *VectorR\i = *VectorR\i - *VectorA\i
    *VectorR\j = *VectorR\j - *VectorA\j
    *VectorR\k = *VectorR\k - *VectorA\k
    
  EndProcedure
  
  Procedure AddScaled(*VectorR.Vector3, *VectorA.Vector3, Scale.d)
    
    *VectorR\i = *VectorR\i + *VectorA\i * Scale
    *VectorR\j = *VectorR\j + *VectorA\j * Scale
    *VectorR\k = *VectorR\k + *VectorA\k * Scale
    
  EndProcedure
  
  Procedure Unit(*VectorR.Vector3, *VectorA.Vector3 = #Null)
    
    ; Le calcule du module dans une variable tampon est ncessaire puisque
    ; l'criture et la lecture se fait dans la mme zone mmoire.
    ; Le calcul du module dpend de la valeur i, j et k du vecteur.

    If *VectorA <> #Null
      
      Unit_Vector3_Modulus.d = Modulus(*VectorA)
      
      If Unit_Vector3_Modulus <> 0.0
        DivideByScalar(*VectorR, *VectorA, Unit_Vector3_Modulus)
      EndIf 
      
    Else
      
      Unit_Vector3_Modulus.d = Modulus(*VectorR)
      
      If Unit_Vector3_Modulus <> 0.0
        DivideByScalar(*VectorR, *VectorR, Unit_Vector3_Modulus)
      EndIf 
      
    EndIf
    
  EndProcedure 
  
  Procedure DefaultLocalAxis(*X_Axis.Vector3, *Y_Axis.Vector3, *Z_Axis.Vector3)
    
    *X_Axis\i = 1.0
    *X_Axis\j = 0.0
    *X_Axis\k = 0.0
    
    *Y_Axis\i = 0.0
    *Y_Axis\j = 1.0
    *Y_Axis\k = 0.0
    
    *Z_Axis\i = 0.0
    *Z_Axis\j = 0.0
    *Z_Axis\k = 1.0
    
  EndProcedure 

  Procedure AimingPoint(*Amaing.Vector3, *Position.Vector3, *Direction.Vector3, Distance.d)
    
    *Amaing\i = *Position\i + (*Direction\i * Distance)
    *Amaing\j = *Position\j + (*Direction\j * Distance)
    *Amaing\k = *Position\k + (*Direction\k * Distance)
    
  EndProcedure
  
  Procedure Turncate(*VectorA.Vector3, MaxLength.d)
    
    Unit_Vector3_Modulus.d = Modulus(*VectorA)
    
    If Unit_Vector3_Modulus >= MaxLength
      ProductByScalar(*VectorA, *VectorA, (MaxLength / Unit_Vector3_Modulus))
    EndIf
    
  EndProcedure
  
  
EndModule

CompilerIf #PB_Compiler_IsMainFile
  
  Vector3::One(VecteurA.Vector3::Vector3)
  Vector3::One(VecteurB.Vector3::Vector3)  
  
  Debug Vector3::Compare(VecteurA, VecteurB)
  
  Vector3::Plus(VecteurR.Vector3::Vector3, VecteurA, VecteurB)
  
  Debug Vector3::Format(VecteurR)
  
  Vector3::DefaultLocalAxis(X_Axis.Vector3::Vector3, Y_Axis.Vector3::Vector3, Z_Axis.Vector3::Vector3)
  
  Vector3::AimingPoint(Amaing.Vector3::Vector3, Position.Vector3::Vector3, Z_Axis, 2500)
  Debug ""
  Debug Vector3::Format(Position)
  Debug Vector3::Format(Z_Axis)
  Debug Vector3::Format(Amaing)
  Debug ""
  
  
  
  Vector3::Update(VecteurP.Vector3::Vector3, 2, -1, 7)
  Vector3::Update(VecteurQ.Vector3::Vector3, 1, -3, 5)
  
  Debug Vector3::Distance(VecteurP, VecteurQ) 
  
  
  
  
  
  
  
CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = -------
; EnableXP
; CompileSourceDirectory
; EnableUnicode